ru.bitel.bgbilling.modules.cerbercrypt.server.bean

## Class CardManager

- java.lang.Object
- - ru.bitel.bgbilling.modules.cerbercrypt.server.bean.CardManager

-     public class CardManager
      extends java.lang.Object

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `CardManager(java.sql.Connection con, int mid, int userId)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `boolean` | `addCard(Card card)` Добавление карты.
    `int` | `addCardsToDealer(int dealerId, java.util.Calendar date, long numberFrom, long numberTo)` Дать карты дилеру по диапазону.
    `void` | `deleteCard(long number, boolean check)` Удаление карты по номеру.
    `java.util.List<java.lang.Long>` | `getAllCardNumbers()` Возвращает номера всех карт заведённых.
    `Card` | `getCard(long number)` Получение карты по номеру.
    `java.util.List<Card>` | `getCardsOfDealer(int dealerId)` Список всех карт указанного дилера.
    `java.util.List<java.lang.Long>` | `getFreeCardNumbers()` Позвращает номера свободных карт (заведённых, но не стоящих ни в одном договоре).
    `java.util.List<Card>` | `getFullCardList()` Полный список всех заведённых карт без исключения.
    `int` | `removeCardsFromDealer(int dealerId, long numberFrom, long numberTo)` Забрать карты у дилера по диапазону.
    `void` | `updateCard(Card card)` Обновление карты.
    `boolean` | `updateCardContract(Card card, java.util.Calendar date)` Обновление договора и даты_договора карты на основании соответствующей сиюминутной юзеркарты, её содержащей.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### CardManager

          public CardManager(java.sql.Connection con,
                             int mid,
                             int userId)

  - ### Method Detail

    - #### getCard

          public Card getCard(long number)
                       throws ru.bitel.bgbilling.common.BGException

      Получение карты по номеру.
      Parameters:
        `number` - номер карты
      Returns:
        карта
      Throws:
        `ru.bitel.bgbilling.common.BGException` - ошибки

    - #### addCard

          public boolean addCard(Card card)
                          throws ru.bitel.bgbilling.common.BGException

      Добавление карты. Используется в загрузчике. Добавляются поля "номер" и "пароль"(передавать пустую строку если не надо) и "дилер"/"дата передачи"(передавать 0 если не надо).
      Parameters:
        `card` - карта
      Returns:
        успешно ли (иначе "карта уже есть").
      Throws:
        `ru.bitel.bgbilling.common.BGException` - все остальные ошибки

    - #### updateCard

          public void updateCard(Card card)
                          throws ru.bitel.bgbilling.common.BGException

      Обновление карты. В качестве ключа используется номер.
      Parameters:
        `card` - карта
      Throws:
        `ru.bitel.bgbilling.common.BGException` - ошибки

    - #### deleteCard

          public void deleteCard(long number,
                                 boolean check)
                          throws ru.bitel.bgbilling.common.BGException

      Удаление карты по номеру.
      Parameters:
        `number` - номер карты.
        `check` - делать проверки возможности удаления (крайне рекомендуется).
      Throws:
        `ru.bitel.bgbilling.common.BGException` - ошибки

    - #### removeCardsFromDealer

          public int removeCardsFromDealer(int dealerId,
                                           long numberFrom,
                                           long numberTo)
                                    throws ru.bitel.bgbilling.common.BGException

      Забрать карты у дилера по диапазону.
      Parameters:
        `dealerId` - дилер
        `numberFrom` - номер от, включительно
        `numberTo` - номер до, включительно
      Returns:
        количество операций произведённых
      Throws:
        `ru.bitel.bgbilling.common.BGException` - ошибки

    - #### addCardsToDealer

          public int addCardsToDealer(int dealerId,
                                      java.util.Calendar date,
                                      long numberFrom,
                                      long numberTo)
                               throws ru.bitel.bgbilling.common.BGException

      Дать карты дилеру по диапазону.
      Parameters:
        `dealerId` - дилер
        `date` - дата
        `numberFrom` - номер от, включительно
        `numberTo` - номер до, включительно
      Returns:
        количество операций произведённых
      Throws:
        `ru.bitel.bgbilling.common.BGException` - ошибки

    - #### getCardsOfDealer

          public java.util.List<Card> getCardsOfDealer(int dealerId)
                                                throws ru.bitel.bgbilling.common.BGException

      Список всех карт указанного дилера.
      Throws:
        `ru.bitel.bgbilling.common.BGException`

    - #### updateCardContract

          public boolean updateCardContract(Card card,
                                            java.util.Calendar date)
                                     throws ru.bitel.bgbilling.common.BGException

      Обновление договора и даты_договора карты на основании соответствующей сиюминутной юзеркарты, её содержащей. Если изменений нет, то реального апдейта карты не происходит.
      Parameters:
        `card` - карта
        `date` - дата
      Returns:
        true - если произошло обновление
      Throws:
        `ru.bitel.bgbilling.common.BGException` - ошибки

    - #### getFullCardList

          public java.util.List<Card> getFullCardList()
                                               throws ru.bitel.bgbilling.common.BGException

      Полный список всех заведённых карт без исключения.
      Throws:
        `ru.bitel.bgbilling.common.BGException` - ошибки

    - #### getAllCardNumbers

          public java.util.List<java.lang.Long> getAllCardNumbers()
                                                           throws ru.bitel.bgbilling.common.BGException

      Возвращает номера всех карт заведённых.
      Returns:
        список длинных целых чисел. Используются таблицы card_.
      Throws:
        `ru.bitel.bgbilling.common.BGException` - ошибка.

    - #### getFreeCardNumbers

          public java.util.List<java.lang.Long> getFreeCardNumbers()
                                                            throws ru.bitel.bgbilling.common.BGException

      Позвращает номера свободных карт (заведённых, но не стоящих ни в одном договоре). Используются таблицы card_ и user_card_.
      Returns:
        список длинных целых чисел.
      Throws:
        `ru.bitel.bgbilling.common.BGException` - ошибка.